"use strict";

const util = require("util");
const chalk = require("chalk");

module.exports = function createDebugMiddleware() {
	return function (req, res, next) {
		console.log(`## ${chalk.cyan(req.method)} ${chalk.bold.yellow(req.url)}`);
		
		console.log(util.inspect({
			query: req.query,
			params: req.params,
			host: req.hostname,
			headers: req.headers,
			cookies: req.cookies,
			body: req.body
		}, {colors: true, depth: null}));
		
		next();
	}
};